#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
#define less lesss
typedef long long ll;
typedef long double dbl;

using namespace std;

const int MAXN = 1 << 18;
const int MOD = 1; // 1000 * 1000 * 1000 + 7;
const dbl EPS = 1e-9;

bool eq(dbl a, dbl b) {
	return fabs(a - b) / max((dbl)1.0, max(fabs(a), fabs(b))) < EPS;
}

bool less(dbl a, dbl b) {
	return !eq(a, b) && a < b;
}

int main() {
	freopen("player.in", "r", stdin);
	freopen("player.out", "w", stdout);

	int n, v, F;
	while (scanf("%d%d%d", &n, &v, &F) == 3) {
		vector<int> t(n), k(n);
		vector<vector<int> > l(n), r(n), f(n);
		for (int i = 0; i < n; i++) {
			scanf("%d%d", &t[i], &k[i]);
			l[i].resize(k[i]);
			r[i].resize(k[i]);
			f[i].resize(k[i]);
			for (int j = 0; j < k[i]; j++) {
				scanf("%d%d%d", &l[i][j], &r[i][j], &f[i][j]);
			}
			if (k[i] == 0) {
				l[i].push_back(0);
				r[i].push_back(t[i]);
				f[i].push_back(0);
				k[i] = 1;
				continue;
			}
			if (r[i][k[i] - 1] != t[i]) {
				l[i].push_back(r[i][k[i] - 1]);
				r[i].push_back(t[i]);
				f[i].push_back(0);
			}
			if (l[i][0] != 0) {
				r[i].insert(r[i].begin(), l[i][0]);
				l[i].insert(l[i].begin(), 0);
				f[i].insert(f[i].begin(), 0);
			}
			vector<int> nl, nr, nf;
			for (int j = 0; j < (int)l[i].size(); j++) {
				nl.push_back(l[i][j]);
				nr.push_back(r[i][j]);
				nf.push_back(f[i][j]);
				if (j + 1 < (int)l[i].size() && l[i][j + 1] > r[i][j]) {
					nl.push_back(r[i][j]);
					nr.push_back(l[i][j + 1]);
					nf.push_back(0);
				}
			}
			l[i] = nl;
			r[i] = nr;
			f[i] = nf;
			k[i] = l[i].size();
		}

		auto cmp = [&f](const pair<int, int> &a, const pair<int, int> &b) {
			return f[a.first][a.second] > f[b.first][b.second];
		};
		priority_queue < pair<int, int>, vector<pair<int, int> >, decltype(cmp) > q(cmp);
		dbl cur = 0.0;
		int sum = 0;
		ll cf = 0;
		dbl ans = 1e20;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < k[i]; j++) {
				if (v == 1 && cf + (r[i][j] - l[i][j]) * 1LL * f[i][j] >= F - EPS) {
					ans = cur + (F - cf) / (dbl)f[i][j];
					goto end;
				}
				cf += (r[i][j] - l[i][j]) * 1LL * f[i][j];
				cur += r[i][j] - l[i][j];

				q.push(make_pair(i, j));
				bool deleted = 0;
				while (1) {
					if (!less(cf, F) && f[i][j] != 0 && !deleted) {
						dbl res = cur - (r[i][j] - l[i][j]) + max((dbl)0.0, (F - (cf - (r[i][j] - l[i][j]) * 1LL * f[i][j])) / (dbl)f[i][j]);
						ans = min(ans, res);
					}
					int ci = q.top().first;
					int cj = q.top().second;
					if (cf - (r[ci][cj] - l[ci][cj]) * 1LL * f[ci][cj] < F) {
						break;
					}
					cur -= r[ci][cj] - l[ci][cj];
					cur += (r[ci][cj] - l[ci][cj]) / (dbl)v;
					cf -= (r[ci][cj] - l[ci][cj]) * 1LL * f[ci][cj];
					deleted |= ci == i && cj == j;
					q.pop();
					continue;
				}
				if (!less(cf, F)) {
					int ci = q.top().first;
					int cj = q.top().second;
					dbl need = F - (cf - (r[ci][cj] - l[ci][cj]) * 1LL * f[ci][cj]);
					dbl res = cur - (r[ci][cj] - l[ci][cj]);
					ans = min(ans, res + need / f[ci][cj] + (ci == i && cj == j ? 0 : (r[ci][cj] - l[ci][cj] - need / f[ci][cj]) / v));
				}
			}
		}
	end:;
		if (ans > 1e19) ans = -1;
		printf("%.15f\n", (double)ans);
	}

	return 0;
}