import java.io.*;
import java.util.StringTokenizer;

public class registers_ip_n2 {
    public static final int LOG_N = 17;
    public static final String TASK = "registers";

    FastScanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int n = in.nextInt();
        int k = in.nextInt();
        int[] a = new int[n], b = new int[n];
        String as = in.next();
        String bs = in.next();
        for (int i = 0; i < n; ++i) {
            a[n - i - 1] = as.charAt(i) - '0';
            b[n - i - 1] = bs.charAt(i) - '0';
        }

        int[] p = new int[LOG_N];
        for (int i = 0; i < k; ++i) {
            int h = in.nextInt();
            int cs = in.nextInt();
            p[h] = cs;
        }

        int m = in.nextInt();
        if (n > 1000 || m > 1000)
            throw new AssertionError("n > 1000 || m > 1000");
        for (int i = 0; i < m; ++i) {
            int num = in.nextInt();
            int bit = in.nextInt();
            if (num == 1) a[bit] ^= 1;
            else b[bit] ^= 1;

            int carry = 0;
            int[] cnt = new int[LOG_N];
            for (int j = 0; j < n; ++j) {
                carry = (carry + a[j] + b[j]) >> 1;
                for (int bt = 0; bt < LOG_N; ++bt)
                    if ((j + 1) % (1<<bt) == 0)
                        cnt[bt] += carry;
            }
            int ans = Integer.MAX_VALUE;
            for (int bt = 0; bt < LOG_N; ++bt)
                if (p[bt] != 0)
                    ans = Math.min(ans, cnt[bt] * p[bt]);
            out.println(ans);
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK + ".in"));
            out = new PrintWriter(new File(TASK + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new registers_ip_n2().run();
    }
}
